searchData={"items":[{"type":"module","title":"Turbojpeg","doc":"# TurboJPEG\n\nFast JPEG encoding from raw YUV data using [libjpeg-turbo](https://libjpeg-turbo.org/)\n\n[![CircleCI](https://circleci.com/gh/BinaryNoggin/elixir-turbojpeg/tree/master.svg?style=svg)](https://circleci.com/gh/BinaryNoggin/elixir-turbojpeg/tree/master)","ref":"Turbojpeg.html"},{"type":"module","title":"Installation - Turbojpeg","doc":"This library requires libjpeg-turbo to be installed\n\n#","ref":"Turbojpeg.html#module-installation"},{"type":"module","title":"Arch linux - Turbojpeg","doc":"sudo pacman -S libjpeg-turbo\n\n#","ref":"Turbojpeg.html#module-arch-linux"},{"type":"module","title":"Ubuntu/Debian - Turbojpeg","doc":"sudo apt-get install libturbojpeg libturbojpeg0-dev\n\n#","ref":"Turbojpeg.html#module-ubuntu-debian"},{"type":"module","title":"OSX - Turbojpeg","doc":"brew install libjpeg-turbo\n    \n#","ref":"Turbojpeg.html#module-osx"},{"type":"module","title":"Develement Dependencies - Turbojpeg","doc":"#","ref":"Turbojpeg.html#module-develement-dependencies"},{"type":"module","title":"Arch linux - Turbojpeg","doc":"sudo pacman -S imagemagick\n\n#","ref":"Turbojpeg.html#module-arch-linux"},{"type":"module","title":"Ubuntu/Debian - Turbojpeg","doc":"sudo apt-get install imagemagick\n\n#","ref":"Turbojpeg.html#module-ubuntu-debian"},{"type":"module","title":"OSX - Turbojpeg","doc":"brew install imagemagick\n\nIf [available in Hex](https://hex.pm/packages/turbojpeg), the package can be installed\nby adding `turbojpeg` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:turbojpeg, \"~> 0.4\"}\n  ]\nend\n```","ref":"Turbojpeg.html#module-osx"},{"type":"module","title":"Basic Usage - Turbojpeg","doc":"```elixir \niex(1)> frame = File.read!(\"fixture/i420.yuv\")\n >\niex(2)> {:ok, jpeg} = Turbojpeg.yuv_to_jpeg(frame, 1920, 1080, 90, :I420)\n{:ok,  >}\niex(3)> File.write!(\"test.jpg\", jpeg)\n:ok\n```","ref":"Turbojpeg.html#module-basic-usage"},{"type":"module","title":"Membrane Sink Usage - Turbojpeg","doc":"In this example we'll read an H264 encoded frame and save it as a JPEG image\n\n```elixir\ndefmodule Your.Module.Pipeline do\n  use Membrane.Pipeline\n\n  alias Membrane.{File, H264}\n\n  @impl true\n  def handle_init(_ctx, _opts) do\n    children = [\n      child(:source, %File.Source{location: \"input.h264\"})\n      |> child(:parser, H264.Parser)\n      |> child(:decoder, H264.FFmpeg.Decoder)\n      |> child(:sink, %Turbojpeg.Sink{filename: \"/tmp/frame.jpeg\", quality: 100})\n    ]\n\n    {[spec: spec], %{}}\n  end\n\n  @impl true\n  def handle_element_end_of_stream(:sink, _ctx, state) do\n    {[terminate: :normal], state}\n  end\nend\n```\n\n# Copyright and License\n\nCopyright 2023, Binary Noggin","ref":"Turbojpeg.html#module-membrane-sink-usage"},{"type":"function","title":"Turbojpeg.get_jpeg_header/1","doc":"Gets the header from a jpeg binary","ref":"Turbojpeg.html#get_jpeg_header/1"},{"type":"function","title":"Examples - Turbojpeg.get_jpeg_header/1","doc":"iex> {:ok, header} = Turbojpeg.get_jpeg_header(jpeg)\n       {:ok,\n         %Turbojpeg.JpegHeader{\n            format: :I422,\n            width: 192,\n            height: 192\n          }\n       }\n\n    iex> Turbojpeg.get_jpeg_header( >)\n       {:error, \"Not a JPEG file: starts with 0x2d 0x30\"}","ref":"Turbojpeg.html#get_jpeg_header/1-examples"},{"type":"function","title":"Turbojpeg.jpeg_to_yuv/1","doc":"Converts jpeg to yuv\n\n\n      iex> {:ok, yuv} = Turbojpeg.jpeg_to_yuv(jpeg)\n        {:ok, >}","ref":"Turbojpeg.html#jpeg_to_yuv/1"},{"type":"function","title":"Turbojpeg.yuv_to_jpeg/5","doc":"Converts yuv to jpeg images\n\n\n      iex> {:ok, jpeg} = Turbojpeg.yuv_to_jpeg(frame, 1920, 1080, 90, :I420)\n        {:ok,  >}","ref":"Turbojpeg.html#yuv_to_jpeg/5"},{"type":"type","title":"Turbojpeg.dimension/0","doc":"","ref":"Turbojpeg.html#t:dimension/0"},{"type":"type","title":"Turbojpeg.error/0","doc":"","ref":"Turbojpeg.html#t:error/0"},{"type":"type","title":"Turbojpeg.format/0","doc":"","ref":"Turbojpeg.html#t:format/0"},{"type":"type","title":"Turbojpeg.height/0","doc":"","ref":"Turbojpeg.html#t:height/0"},{"type":"type","title":"Turbojpeg.quality/0","doc":"","ref":"Turbojpeg.html#t:quality/0"},{"type":"type","title":"Turbojpeg.width/0","doc":"","ref":"Turbojpeg.html#t:width/0"},{"type":"module","title":"Turbojpeg.Filter","doc":"Membrane filter converting raw video frames to JPEG.","ref":"Turbojpeg.Filter.html"},{"type":"module","title":"Element options - Turbojpeg.Filter","doc":"Passed via struct `t:Turbojpeg.Filter.t/0`\n\n- `quality`  \n\n  ```\n  Turbojpeg.quality()\n  ```\n  \n  Default value: `75`  \n  Jpeg encoding quality","ref":"Turbojpeg.Filter.html#module-element-options"},{"type":"module","title":"Pads - Turbojpeg.Filter","doc":"### `:input`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: pix_fmt} when pix_fmt in [:I420, :I422, :I444]\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\nRemoteStream\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Turbojpeg.Filter.html#module-pads"},{"type":"function","title":"Turbojpeg.Filter.options/0","doc":"Returns description of options available for this module","ref":"Turbojpeg.Filter.html#options/0"},{"type":"type","title":"Turbojpeg.Filter.t/0","doc":"Struct containing options for `Turbojpeg.Filter`","ref":"Turbojpeg.Filter.html#t:t/0"},{"type":"module","title":"Turbojpeg.JpegHeader","doc":"Structure representing JPEG image header information.","ref":"Turbojpeg.JpegHeader.html"},{"type":"type","title":"Turbojpeg.JpegHeader.t/0","doc":"The header contains the following information:\n  * `width` - The width of the image.\n  * `height` - The height of the image.\n  * `format` - The pixel format of the image.","ref":"Turbojpeg.JpegHeader.html#t:t/0"},{"type":"module","title":"Turbojpeg.Native","doc":"","ref":"Turbojpeg.Native.html"},{"type":"function","title":"Turbojpeg.Native.get_jpeg_header/1","doc":"","ref":"Turbojpeg.Native.html#get_jpeg_header/1"},{"type":"function","title":"Turbojpeg.Native.jpeg_to_yuv/1","doc":"","ref":"Turbojpeg.Native.html#jpeg_to_yuv/1"},{"type":"function","title":"Turbojpeg.Native.yuv_to_jpeg/5","doc":"","ref":"Turbojpeg.Native.html#yuv_to_jpeg/5"},{"type":"module","title":"Turbojpeg.Sink","doc":"Element responsible for converting YUV binary data to jpeg image format using `turbojpeg`.","ref":"Turbojpeg.Sink.html"},{"type":"module","title":"Element options - Turbojpeg.Sink","doc":"Passed via struct `t:Turbojpeg.Sink.t/0`\n\n- `filename`  \n\n  ```\n  binary()\n  ```\n  \n  ***Required***  \n  File to write the jpeg data\n\n\n- `quality`  \n\n  ```\n  non_neg_integer()\n  ```\n  \n  Default value: `75`  \n  Jpeg encoding quality","ref":"Turbojpeg.Sink.html#module-element-options"},{"type":"module","title":"Pads - Turbojpeg.Sink","doc":"### `:input`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: pix_fmt} when pix_fmt in [:I420, :I422, :I444]\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Turbojpeg.Sink.html#module-pads"},{"type":"function","title":"Turbojpeg.Sink.options/0","doc":"Returns description of options available for this module","ref":"Turbojpeg.Sink.html#options/0"},{"type":"type","title":"Turbojpeg.Sink.t/0","doc":"Struct containing options for `Turbojpeg.Sink`","ref":"Turbojpeg.Sink.html#t:t/0"},{"type":"extras","title":"TurboJPEG","doc":"# TurboJPEG\n\nFast JPEG encoding from raw YUV data using [libjpeg-turbo](https://libjpeg-turbo.org/)\n\n[![CircleCI](https://circleci.com/gh/BinaryNoggin/elixir-turbojpeg/tree/master.svg?style=svg)](https://circleci.com/gh/BinaryNoggin/elixir-turbojpeg/tree/master)","ref":"readme.html"},{"type":"extras","title":"Installation - TurboJPEG","doc":"This library requires libjpeg-turbo to be installed\n\n#","ref":"readme.html#installation"},{"type":"extras","title":"Arch linux - TurboJPEG","doc":"sudo pacman -S libjpeg-turbo\n\n#","ref":"readme.html#arch-linux"},{"type":"extras","title":"Ubuntu/Debian - TurboJPEG","doc":"sudo apt-get install libturbojpeg libturbojpeg0-dev\n\n#","ref":"readme.html#ubuntu-debian"},{"type":"extras","title":"OSX - TurboJPEG","doc":"brew install libjpeg-turbo\n    \n#","ref":"readme.html#osx"},{"type":"extras","title":"Develement Dependencies - TurboJPEG","doc":"#","ref":"readme.html#develement-dependencies"},{"type":"extras","title":"Arch linux - TurboJPEG","doc":"sudo pacman -S imagemagick\n\n#","ref":"readme.html#arch-linux"},{"type":"extras","title":"Ubuntu/Debian - TurboJPEG","doc":"sudo apt-get install imagemagick\n\n#","ref":"readme.html#ubuntu-debian"},{"type":"extras","title":"OSX - TurboJPEG","doc":"brew install imagemagick\n\nIf [available in Hex](https://hex.pm/packages/turbojpeg), the package can be installed\nby adding `turbojpeg` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:turbojpeg, \"~> 0.4\"}\n  ]\nend\n```","ref":"readme.html#osx"},{"type":"extras","title":"Basic Usage - TurboJPEG","doc":"```elixir \niex(1)> frame = File.read!(\"fixture/i420.yuv\")\n >\niex(2)> {:ok, jpeg} = Turbojpeg.yuv_to_jpeg(frame, 1920, 1080, 90, :I420)\n{:ok,  >}\niex(3)> File.write!(\"test.jpg\", jpeg)\n:ok\n```","ref":"readme.html#basic-usage"},{"type":"extras","title":"Membrane Sink Usage - TurboJPEG","doc":"In this example we'll read an H264 encoded frame and save it as a JPEG image\n\n```elixir\ndefmodule Your.Module.Pipeline do\n  use Membrane.Pipeline\n\n  alias Membrane.{File, H264}\n\n  @impl true\n  def handle_init(_ctx, _opts) do\n    children = [\n      child(:source, %File.Source{location: \"input.h264\"})\n      |> child(:parser, H264.Parser)\n      |> child(:decoder, H264.FFmpeg.Decoder)\n      |> child(:sink, %Turbojpeg.Sink{filename: \"/tmp/frame.jpeg\", quality: 100})\n    ]\n\n    {[spec: spec], %{}}\n  end\n\n  @impl true\n  def handle_element_end_of_stream(:sink, _ctx, state) do\n    {[terminate: :normal], state}\n  end\nend\n```\n\n# Copyright and License\n\nCopyright 2023, Binary Noggin","ref":"readme.html#membrane-sink-usage"}],"content_type":"text/markdown"}